/***************************************************************************
 * sound_manager.cpp  -  Sound Handler/Manager
 *
 * Copyright (C) 2006 - 2008 Florian Richter
 ***************************************************************************/
/*
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "../audio/sound_manager.h"

/* *** *** *** *** *** *** cSound_Manager *** *** *** *** *** *** *** *** *** *** *** */

cSound_Manager :: cSound_Manager( void )
: cObject_Manager<cAudio_Sound>()
{
	load_count = 0;
}

cSound_Manager :: ~cSound_Manager( void )
{
	Delete_All();
}

cAudio_Sound *cSound_Manager :: Get_Pointer( string path )
{
	for( SoundList::iterator itr = objects.begin(), itr_end = objects.end(); itr != itr_end; ++itr )
	{
		cAudio_Sound *obj = (*itr);

		if( obj->filename.compare( path ) == 0 )
		{
			// return first found
			return obj;
		}
	}

	// not found
	return NULL;
}

void cSound_Manager :: Add( cAudio_Sound *sound )
{
	load_count++;
	cObject_Manager<cAudio_Sound>::Add( sound );
}

void cSound_Manager :: Delete_Sounds( void )
{
	for( SoundList::iterator itr = objects.begin(), itr_end = objects.end(); itr != itr_end; ++itr )
	{
		cAudio_Sound *obj = (*itr);

		delete obj;
		obj = NULL;
	}
}

/* *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** */

cSound_Manager *pSound_Manager = NULL;
